// Sorted array-based list
// Inherits from AList as a protected base class
template <class Elem, class Comp, class getKey>
class SAList: protected AList<Elem> {
public:
  SAList(int size=DefaultListSize) : AList<Elem>(size) {}

  ~SAList() {}                    // Destructor

  // Redefine insert function to keep values sorted
  bool insert(const Elem& item) { // Insert at right
    Elem curr;
    for (setStart(); getValue(curr); next())
      if(!Comp::lt(getKey::key(curr), getKey::key(item)))
        break;
    return AList<Elem>::insert(item);
  }

  // With the exception of append, all remaining methods are
  // exposed from AList. Append is not available to SAlist class
  // users since it has not been explicitly exposed.
  AList<Elem>::clear;
  AList<Elem>::remove;
  AList<Elem>::setStart;
  AList<Elem>::setEnd;
  AList<Elem>::prev;
  AList<Elem>::next;
  AList<Elem>::leftLength;
  AList<Elem>::rightLength;
  AList<Elem>::setPos;
  AList<Elem>::getValue;
  AList<Elem>::print;
};
